/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

const React = require('react');
const { PydioContextConsumer } = Pydio.requireLib('boot');
const {ActivityList} = require('pydio').requireLib('PydioActivityStreams');

class ActivityStreamsPanel extends React.Component{

    render(){
        if (this.props.pydio.user && ActivityList) {
            return (
                <ActivityList
                    context="USER_ID"
                    contextData={this.props.pydio.user.id}
                    boxName="outbox"
                    style={{overflowY:'scroll', flex: 1}}
                    pointOfView="ACTOR"
                    groupByDate={true}
                />
            );
        } else {
            return <div>No ActivityList?</div>;
        }

    }

}

ActivityStreamsPanel = PydioContextConsumer(ActivityStreamsPanel);
export {ActivityStreamsPanel as default};