'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _modelDataSource = require('../model/DataSource');

var _modelDataSource2 = _interopRequireDefault(_modelDataSource);

var _modelWorkspace = require('../model/Workspace');

var _modelWorkspace2 = _interopRequireDefault(_modelWorkspace);

var _materialUi = require('material-ui');

var React = require('react');

var DataSourceEditor = (function (_React$Component) {
    _inherits(DataSourceEditor, _React$Component);

    function DataSourceEditor(props) {
        _classCallCheck(this, DataSourceEditor);

        _get(Object.getPrototypeOf(DataSourceEditor.prototype), 'constructor', this).call(this, props);
        this.state = {
            dirty: false,
            model: new _modelDataSource2['default'](props.node.getMetadata().get('datasource_id')),
            driverInfo: null,
            loaded: false,
            valid: true
        };
    }

    _createClass(DataSourceEditor, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this = this;

            if (_modelWorkspace2['default'].DRIVERS) {
                this.setState({ driverInfo: _modelWorkspace2['default'].DRIVERS.get('datasource') });
            } else {
                _modelWorkspace2['default'].loadAvailableDrivers(function () {
                    _this.setState({
                        driverInfo: _modelWorkspace2['default'].DRIVERS.get('datasource')
                    });
                });
            }
            this.state.model.load(function () {
                _this.setState({ loaded: true });
            });
        }
    }, {
        key: 'resetForm',
        value: function resetForm() {
            this.setState({ valid: true, dirty: false, saveValues: null });
        }
    }, {
        key: 'deleteSource',
        value: function deleteSource() {
            var _this2 = this;

            if (confirm('Are you sure you want to delete this datasource? This is undoable, and you may loose all data linked to these nodes!')) {
                this.state.model.deleteSource(function () {
                    _this2.props.closeEditor();
                    _this2.props.reloadList();
                });
            }
        }
    }, {
        key: 'saveSource',
        value: function saveSource() {
            var _this3 = this;

            if (this.state.saveValues) {
                this.state.model.saveSource(this.state.saveValues, function () {
                    _this3.setState({ valid: true, dirty: false, saveValues: null });
                    _this3.props.reloadList();
                });
            }
        }
    }, {
        key: 'onFormChange',
        value: function onFormChange(values) {
            this.setState({ saveValues: values, dirty: true });
        }
    }, {
        key: 'updateValidStatus',
        value: function updateValidStatus(valid) {
            this.setState({ valid: valid });
        }
    }, {
        key: 'launchResync',
        value: function launchResync() {
            this.state.model.resyncSource();
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state;
            var loaded = _state.loaded;
            var driverInfo = _state.driverInfo;
            var model = _state.model;

            var form = undefined;
            if (driverInfo && loaded) {
                var values = model.getDataWithPrefix('DATASOURCE_');
                if (this.state.saveValues) {
                    values = this.state.saveValues;
                }
                var params = JSON.parse(JSON.stringify(driverInfo.params));
                if (params.length > 2) {
                    params[0].readonly = true;
                    params[0].description = 'You cannot edit datasource name, delete it and create a new one instead.';
                    params[1].readonly = true;
                    params[1].descripton = 'Changing a datasource path may loose the indexation data and all attached metadata.';
                }
                form = React.createElement(PydioForm.FormPanel, {
                    parameters: params,
                    values: values,
                    className: 'full-width',
                    onChange: this.onFormChange.bind(this),
                    onValidStatusChange: this.updateValidStatus.bind(this),
                    depth: -2
                });
            }

            var titleActionBarButtons = [];
            titleActionBarButtons.push(React.createElement(_materialUi.FlatButton, { key: 'delete', label: 'Delete DataSource', secondary: true, onTouchTap: this.deleteSource.bind(this) }));
            titleActionBarButtons.push(React.createElement('div', { className: 'separator', key: 'separator' }));
            titleActionBarButtons.push(React.createElement(_materialUi.FlatButton, { key: 'reset', label: this.context.getMessage('plugins.6'), onTouchTap: this.resetForm.bind(this), secondary: true, disabled: !this.state.dirty }));
            titleActionBarButtons.push(React.createElement(_materialUi.FlatButton, { key: 'save', label: this.context.getMessage('53', ''), onTouchTap: this.saveSource.bind(this), secondary: true, disabled: !this.state.valid || !this.state.dirty }));
            titleActionBarButtons.push(React.createElement(_materialUi.RaisedButton, { key: 'close', label: this.context.getMessage('86', ''), onTouchTap: this.props.closeEditor }));

            var leftNav = React.createElement(
                'div',
                { style: { padding: '6px 16px', color: '#9E9E9E', fontSize: 15, lineHeight: '23px', fontWeight: 500 } },
                React.createElement(
                    'div',
                    { style: { fontSize: 200, paddingBottom: 20 } },
                    React.createElement('i', { className: 'mdi mdi-database' })
                ),
                this.context.getMessage('ws.75'),
                React.createElement('br', null),
                React.createElement('br', null),
                this.context.getMessage('ws.76'),
                React.createElement(
                    'div',
                    { style: { textAlign: 'center', marginTop: 16 } },
                    React.createElement(_materialUi.RaisedButton, { label: "Resync Datasource", onClick: this.launchResync.bind(this) })
                )
            );

            return React.createElement(
                PydioComponents.PaperEditorLayout,
                {
                    title: loaded && driverInfo ? "DataSource " + this.state.model.dsId : "Loading...",
                    titleActionBar: titleActionBarButtons,
                    leftNav: leftNav,
                    className: 'workspace-editor',
                    contentFill: false
                },
                form
            );
        }
    }]);

    return DataSourceEditor;
})(React.Component);

DataSourceEditor.contextTypes = {
    messages: React.PropTypes.object,
    getMessage: React.PropTypes.func
};

exports['default'] = DataSourceEditor;
module.exports = exports['default'];
