'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Observable = require('pydio/lang/observable');
var PydioApi = require('pydio/http/api');

var DataSource = (function (_Observable) {
    _inherits(DataSource, _Observable);

    function DataSource(dsId) {
        _classCallCheck(this, DataSource);

        _get(Object.getPrototypeOf(DataSource.prototype), 'constructor', this).call(this);
        this.dsId = dsId;
        this.loaded = false;
    }

    _createClass(DataSource, [{
        key: 'load',
        value: function load(callback) {
            var _this = this;

            if (this.loaded) {
                callback();
                return;
            }
            PydioApi.getClient().request({
                get_action: 'datasource_load',
                dsId: this.dsId
            }, function (t) {
                _this.data = t.responseJSON;
                _this.loaded = true;
                callback();
            });
        }
    }, {
        key: 'deleteSource',
        value: function deleteSource(callback) {
            PydioApi.getClient().request({
                get_action: 'datasource_delete',
                dsId: this.dsId
            }, function (t) {
                callback();
            });
        }
    }, {
        key: 'resyncSource',
        value: function resyncSource() {
            var callback = arguments.length <= 0 || arguments[0] === undefined ? null : arguments[0];

            PydioApi.getClient().request({
                get_action: 'datasource_resync',
                dsId: this.dsId
            }, function (t) {
                if (callback) {
                    callback();
                }
            });
        }
    }, {
        key: 'saveSource',
        value: function saveSource(values, callback) {
            var _this2 = this;

            PydioApi.getClient().request({
                get_action: 'datasource_edit',
                values: JSON.stringify(values)
            }, function (t) {
                _this2.data = t.responseJSON;
                _this2.loaded = true;
                callback();
            });
        }
    }, {
        key: 'getDataWithPrefix',
        value: function getDataWithPrefix() {
            var _this3 = this;

            var prefix = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

            if (prefix === '') {
                return this.data;
            }
            var data = {};

            Object.keys(this.data).forEach(function (k) {
                data[prefix + k] = _this3.data[k];
            });
            return data;
        }
    }]);

    return DataSource;
})(Observable);

exports['default'] = DataSource;
module.exports = exports['default'];
