<?php
/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */
namespace Pydio\Access\Meta\Version;

use Pydio\Access\Core\AbstractAccessDriver;
use Pydio\Access\Core\Model\Node;
use Pydio\Core\Controller\Controller;
use Pydio\Core\Exception\PydioException;
use Pydio\Core\Model\ContextInterface;
use Pydio\Core\Services\LocaleService;
use Pydio\Core\Services\ApplicationState;
use Pydio\Core\Utils\Vars\InputFilter;
use Pydio\Core\Utils\Vars\StatHelper;

use Pydio\Core\Controller\HTMLWriter;
use Pydio\Access\Meta\Core\AbstractMetaSource;

defined('PYDIO_EXEC') or die('Access not allowed');

/**
 * Manage versioning using Git
 * @package Pydio\Access\Meta\Version
 */
class VersionsManager extends AbstractMetaSource
{

    private $repoBase;

    /**
     * @param \Psr\Http\Message\ServerRequestInterface $requestInterface
     * @param \Psr\Http\Message\ResponseInterface $responseInterface
     */
    public function applyActions(\Psr\Http\Message\ServerRequestInterface $requestInterface, \Psr\Http\Message\ResponseInterface &$responseInterface)
    {
        
        $actionName         = $requestInterface->getAttribute("action");
        $ctx                = $requestInterface->getAttribute("ctx");
        $httpVars           = $requestInterface->getParsedBody();
        $x                  = new \Pydio\Core\Http\Response\SerializableResponseStream();
        $responseInterface  = $responseInterface->withBody($x);
        $userSelection      = \Pydio\Access\Core\Model\UserSelection::fromContext($ctx, $httpVars);

        $git = new \VersionControl_Git($this->repoBase);
        switch ($actionName) {
            case "versions_history":
                $nodesList = new \Pydio\Access\Core\Model\NodesList();
                $selectedNode = $userSelection->getUniqueNode();
                // DO SOMETHING
                $x->addChunk($nodesList);
                break;
            break;

            case "git_revertfile":

                throw new PydioException("Not Implemented");

            break;

            case "git_getfile":

                throw new PydioException("Not Implemented");

            break;

            default:
            break;
        }


    }

}